Name: ircd
Version: 2.10.3
Release: 2
Copyright: GPL
Group: System Environment/Daemons
Source0: ftp://ftp.irc.org/irc/server/irc%{version}.tgz
Source1: ircd.init
Source2: irc%{version}-config.h
Source3: ircd_crypter
Packager: Mihai Ibanescu <misa@redhat.com>
BuildRoot: /var/tmp/%{name}-root
Summary: irc server from ftp.irc.org
%define chrootdir /home/ircd
%define bchrootdir $RPM_BUILD_ROOT%{chrootdir}

%description
ircd is the server (daemon) program for the Internet Relay Chat
Program. The ircd is a server in that its function is to "serve"
the client program irc(1) with messages and commands.
All commands and user messages are passed directly to the ircd
for processing and relaying to other ircd sites.

%changelog
* Wed Jul 18 2001 Mihai Ibanescu <misa@redhat.com>
- Recompiled on Red Hat 7.1
- ALLCAPS suck
* Wed Jan 13 1999 Mihai Ibanescu <misa@necomm.ro>
- Last cleanups before the release of the package in the real world

%prep
%setup -n irc%version

%build
CFLAGS=-D_GNU_SOURCE ./configure \
	--prefix=/usr \
	--libdir=%{chrootdir} \
	--localstatedir=/run \
	--sysconfdir=/etc/ircd \
	--logdir=/log \
	--with-zlib \
	--disable-ipv6
MYARCH=`support/config.guess`
install -m644 %SOURCE2 $MYARCH/config.h
make -C $MYARCH ircd iauth chkconf ircd-mkpasswd
make -C $MYARCH ircdwatch ircd_var_dir=%{chrootdir}/run

%install
rm -rf $RPM_BUILD_ROOT
make -C `support/config.guess` prefix=$RPM_BUILD_ROOT/usr \
	ircd_dir=%{bchrootdir} \
	ircd_conf_dir=%{bchrootdir}/etc/ircd \
	ircd_var_dir=%{bchrootdir}/run \
	ircd_log_dir=%{bchrootdir}/log \
	install-server


install -d -m 755 $RPM_BUILD_ROOT/usr/sbin
install -m 755 %SOURCE3 $RPM_BUILD_ROOT/usr/sbin/ircd-crypter
install -d -m 750 %{bchrootdir}/etc/ircd
install -d -m 750 %{bchrootdir}/lib
install -d -m 750 %{bchrootdir}/usr/sbin
install -d -m 750 %{bchrootdir}/log
install -d -m 750 %{bchrootdir}/run
echo 'This is a poorly installed IRC server (MOTD not edited)' > %{bchrootdir}/etc/ircd/ircd.motd
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 750 $RPM_SOURCE_DIR/ircd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/ircd
# Chroot-related
mv $RPM_BUILD_ROOT/usr/sbin/iauth %{bchrootdir}/usr/sbin
ln -sf ../..%{chrootdir}/usr/sbin/iauth $RPM_BUILD_ROOT/usr/sbin 

ln -sf ..%{chrootdir}/etc/ircd $RPM_BUILD_ROOT/etc/ircd

# Borrowed from anonftp
cat > $RPM_BUILD_ROOT%{chrootdir}/etc/passwd <<EOF
root:*:0:0:::
bin:*:1:1:::
EOF

cat > $RPM_BUILD_ROOT%{chrootdir}/etc/group <<EOF
root::0:
bin::1:
daemon::2:
sys::3:
adm::4:
EOF

%define ldsover 2
%define libcver 2.2.2
%define libcryptver 1
%define libnslver 1
%define libnssver 2
%define libcsover 6

%define root %{bchrootdir}/lib

cp -fd /etc/ld.so.cache %{bchrootdir}/etc
cp -fd /lib/libc.so.%{libcsover} /lib/libc-%{libcver}.so %{root}
cp -fd /lib/ld-linux.so.%{ldsover} /lib/ld-%{libcver}.so %{root}
cp -fd /lib/libcrypt-%{libcver}.so \
	/lib/libcrypt.so.%{libcryptver}	%{root}
cp -fd /lib/libnsl-%{libcver}.so \
	/lib/libnsl.so.%{libnslver}	%{root}
cp -fd /lib/libnss_compat-%{libcver}.so \
	/lib/libnss_compat.so.%{libnssver}	%{root}
cp -fd /lib/libnss_dns-%{libcver}.so \
	/lib/libnss_dns.so.%{libnssver}	%{root}
cp -fd /lib/libnss_files-%{libcver}.so \
	/lib/libnss_files.so.%{libnssver}	%{root}
cp -fd /lib/libresolv-%{libcver}.so \
	/lib/libresolv.so.%{libnssver}	%{root}

strip %{root}/*

%post
chkconfig --add ircd
# Make the resolver happy
install /etc/resolv.conf %{chrootdir}/etc
# Touch the log files
touch %{chrootdir}/log/auth
touch %{chrootdir}/log/opers
touch %{chrootdir}/log/rejects
touch %{chrootdir}/log/users

%preun
if [ $1 = 0 ] ; then
	rm -f %{chrootdir}/etc/resolv.conf
	chkconfig --del ircd
fi

%files
%defattr(-,root,root)
%attr(0444,root,root) %config %{chrootdir}/etc/passwd
%attr(0444,root,root) %config %{chrootdir}/etc/group
%{chrootdir}/etc/ld.so.cache
%{chrootdir}/lib/ld-linux.so.%{ldsover}
%{chrootdir}/lib/ld-%{libcver}.so
%{chrootdir}/lib/libc.so.%{libcsover}
%{chrootdir}/lib/libc-%{libcver}.so
%{chrootdir}/lib/libcrypt-%{libcver}.so
%{chrootdir}/lib/libcrypt.so.%{libcryptver}
%{chrootdir}/lib/libnsl-%{libcver}.so
%{chrootdir}/lib/libnsl.so.%{libnslver}
%{chrootdir}/lib/libnss_compat-%{libcver}.so
%{chrootdir}/lib/libnss_compat.so.%{libnssver}
%{chrootdir}/lib/libnss_dns-%{libcver}.so
%{chrootdir}/lib/libnss_dns.so.%{libnssver}
%{chrootdir}/lib/libnss_files-%{libcver}.so
%{chrootdir}/lib/libnss_files.so.%{libnssver}
%{chrootdir}/lib/libresolv-%{libcver}.so
%{chrootdir}/lib/libresolv.so.%{libnssver}

%attr(0755,root,root) %dir %{chrootdir}

/usr/man/man5/iauth.conf.5.gz
/usr/man/man8/iauth.8.gz
/usr/man/man8/ircd.8.gz
/usr/man/man8/ircdwatch.8.gz
/usr/sbin/chkconf
/usr/sbin/iauth
/usr/sbin/ircd
/usr/sbin/ircd-crypter
/usr/sbin/ircd-mkpasswd
/usr/sbin/ircdwatch
/etc/rc.d/init.d/ircd
/etc/ircd
%config %{chrootdir}/etc/ircd
%dir %{chrootdir}/lib
%{chrootdir}/log
%{chrootdir}/run
%{chrootdir}/usr
%doc doc
